#! /usr/bin/python
## -*- coding: utf-8 -*-

##
##  HARK Middleware
##  Copyright (C) 2013-2014 by Honda Research Institute Japan Co., Ltd.
##
##  $Id:$
##

from harkmw.HarkError import HARKError
from harkmw.defs.node import NodeDef

import harkmw.logic.node

class MQTTNode(harkmw.logic.node.Node) :
    def __init__(self) :
        harkmw.logic.node.Node.__init__(self)
        self.inputs  = {}
        self.outputs = {}
        self.network = None

    def build(self, network, node_def, params) :
        self.network     = network
        self.type        = node_def.type
        self.name        = node_def.name
        self.topic       = node_def.topic
        self.process_name = node_def.get_process_name()

    def process(self, output, count) :
        pass

    def get_input_count(self) :
        return 0

    def get_output_count(self) :
        return 0

    def connect_node(self, terminal_name, node_from, terminal_from_name) :
        pass

    def push_data(self, input, count, internal = False) :
        """ なにもしない """
        pass

    def dump(self) :
        print('[MQTTNode]')
        print('  type: %s' % self.type)
        print('  name: %s' % self.name)
        print('  network: type=%s, name=%s' % (self.network.type, self.network.name))

        print('  inputs: ')
        for (name, terminal) in self.inputs.items() :
            print('    Input: name=%s, node=%s/%s, terminal=%s' % (name, terminal.input_node.type, terminal.input_node.name, terminal.input_terminal_name))

        print('  outputs: ')
        for (name, proxy_list) in self.outputs.items() :
            for proxy in proxy_list :
                print('    Output: name=%s, node=%s/%s, terminal=%s' % (name, proxy.output_node.type, proxy.output_node.name, proxy.output_terminal_name))

    def __str__(self) :
        return "<%s: type=%s, name=%s>" % (self.__class__.__name__, self.type, self.name)

# end of file
    
